unit frmExcelTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, GPExcelKomponente, OleServer, Excel97;

type
  TfrmXL = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    edtZahl: TEdit;
    edtY: TEdit;
    edtX: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    btnStart: TButton;
    btnCancel: TButton;
    btnShow: TButton;
    edtName: TEdit;
    Label4: TLabel;
    btnTrenn: TButton;
    SaveDialog1: TSaveDialog;
    btnSave: TButton;
    sttFileName: TStaticText;
    btnWork: TButton;
    FontDialog1: TFontDialog;
    ColorDialog1: TColorDialog;
    btnRead: TButton;
    btnDelete: TButton;
    edtWidth: TEdit;
    txtWidth: TLabel;
    edtHeight: TEdit;
    lblHeight: TLabel;
    GPExcel: TGPExcel;
    ExcelApplication1: TExcelApplication;
    btnFont: TButton;
    procedure btnCancelClick(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnShowClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnTrennClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnWorkClick(Sender: TObject);
    procedure btxClick(Sender: TObject);
    procedure GPExcelBeforeClose(Sender: TObject);
    procedure btnReadClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);

  private


  public
    { Public-Deklarationen }
  end;

var
  frmXL: TfrmXL;

implementation

{$R *.DFM}

procedure TfrmXL.btnCancelClick(Sender: TObject);
begin
  close;
end; { btnCancelClick }

{ ----- }

procedure TfrmXL.btnStartClick(Sender: TObject);
begin
  btnStart.Enabled := false;
  GPExcel.Active := TRUE;
  btnTrenn.Enabled := GPExcel.Active;
end; { btnStartClick }

{ ----- }

procedure TfrmXL.btnShowClick(Sender: TObject);
VAR
  X,Y : integer;

begin
  GPExcel.Active := TRUE;
  X := StrToInt(edtX.Text);
  Y := StrToInt(edtY.Text);
  GPExcel.SheetCell[edtName.Text, X, Y] := edtZahl.Text;
  IF edtWidth.Text <> ''
  THEN GPExcel.CellWidth[X] := StrToInt(edtWidth.Text);
  IF edtHeight.Text <> ''
  THEN GPExcel.CellHeight[Y]:= StrToInt(edtHeight.Text);
end;

{ ----- }

procedure TfrmXL.btnWorkClick(Sender: TObject);
var
  zz : integer;
  X  : integer;
  y  : integer;
  Old: TSetCellPropertys;

begin
  zz := StrToInt(edtZahl.Text);

  Old:= GPExcel.ActiveCellProperty;
  GPExcel.ActiveCellProperty := [];
  for y := 1 to 500 do
  begin
    edtY.Text := IntToStr(y);
    edtZahl.Text := IntToStr(zz + y);
    btnShowClick(Sender);
    IF y = 1
    THEN GPExcel.ScreenUpdate := false;
  end;

  GPExcel.ActiveCellProperty := Old;
  X := StrToInt(edtX.Text);
  GPExcel.CellPropertysToArea(X,1, X, 500);
  GPExcel.ScreenUpdate := true;
end; { btnWorkClick }

{ ----- }

procedure TfrmXL.FormCreate(Sender: TObject);
begin
  btnTrenn.Enabled := false;
end; { FormCreate }

{ ----- }

procedure TfrmXL.btnTrennClick(Sender: TObject);
begin
  GPExcel.Active := false;
  btnTrenn.Enabled := false;
  btnStart.Enabled := true;
  
end; { btnTrennClick }

{ ----- }

procedure TfrmXL.btnSaveClick(Sender: TObject);
begin
  IF GPExcel.HasChanged THEN
  BEGIN
    SaveDialog1.FileName := GPExcel.FileName;
    IF SaveDialog1.Execute THEN
    BEGIN
      GPExcel.SaveToFile(SaveDialog1.FileName);
    END;
  END;
end;

procedure TfrmXL.btxClick(Sender: TObject);
begin
  IF FontDialog1.Execute THEN
  BEGIN
    GPExcel.Font := FontDialog1.Font;
    edtZahl.Font := FontDialog1.Font;

    ColorDialog1.Color := GPExcel.Color;
    IF ColorDialog1.Execute THEN
    BEGIN
      GPExcel.Color := ColorDialog1.Color;
      edtZahl.Color := ColorDialog1.Color;
    END;
  END;
end; { btnFontClick }

{ ----- }

procedure TfrmXL.GPExcelBeforeClose(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0,
               SWP_NOMOVE or SWP_NOSIZE);
  Application.BringToFront;
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0,
               SWP_NOMOVE or SWP_NOSIZE);

  btnTrenn.Enabled := false;
  btnStart.Enabled := true;

  ShowMessage('Warum schliet du denn Excel?');
end; { GPExcelBeforeClose }

{ ----- }

procedure TfrmXL.btnReadClick(Sender: TObject);
var
  x,y : integer;

begin
  X := StrToInt(edtX.Text);
  Y := StrToInt(edtY.Text);

  edtZahl.Text := GPExcel.SheetCell[edtName.Text, X, Y];
  edtWidth.Text := IntToStr(GPExcel.CellWidth[X]);
  edtHeight.Text := IntToStr(GPExcel.CellHeight[Y]);
end; { btnReadClick }

{ ----- }

procedure TfrmXL.btnDeleteClick(Sender: TObject);
var
  Hd    : THandle;
  Title : string;

begin
  Hd := windows.GetSystemMenu(Handle, false);
  windows.DeleteMenu(Hd, SC_Close, MF_BYCOMMAND);
  windows.DeleteMenu(Hd, 5, MF_ByPosition);

  Hd := windows.GetSystemMenu(Application.Handle, false);
  windows.DeleteMenu(Hd, SC_Close, MF_BYCOMMAND);
  windows.DeleteMenu(Hd, 2, MF_ByPosition);

  Title := GPExcel.Caption;
  Hd := FindWindow(NIL, PCHAR(Title));
  IF Hd <> 0
  THEN windows.DeleteMenu(Hd, SC_Close, MF_BYCOMMAND);
end;

end.
